/*
 * JaamSim Discrete Event Simulation
 * Copyright (C) 2015 Ausenco Engineering Canada Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.jaamsim.input;

public class SynonymInput extends Input<Object> {
	public final Input<?> input;

	public SynonymInput(String key, Input<?> input) {
		super(key, input.getCategory(), null);
		this.input = input;
	}

	@Override
	public boolean isSynonym() {
		return true;
	}

	@Override
	public void parse(KeywordIndex kw) throws InputErrorException {
		input.parse(kw);
	}
}
