" Imperial System of Units

" ======================================================================================================================================================
" Distance units
" ======================================================================================================================================================

Define DistanceUnit { mi ft in }

mi     ConversionFactorToSI { 1609.344 }  Description { 'Statute Miles' }
ft     ConversionFactorToSI { 0.3048   }  Description { 'Feet' }
in     ConversionFactorToSI { 0.0254   }  Description { 'Inches' }

" ======================================================================================================================================================
" Speed units
" ======================================================================================================================================================

Define SpeedUnit { mph }

mph    ConversionFactorToSI { 1609.344 3600 }  Description { 'Miles per Hour' }

" ======================================================================================================================================================
" Acceleration units
" ======================================================================================================================================================

Define AccelerationUnit { ft/s2 }

ft/s2  ConversionFactorToSI { 0.3048 }  Description { 'Feet per Second Squared' }

" ======================================================================================================================================================
" Pressure units
" ======================================================================================================================================================

Define PressureUnit { psi }

psi    ConversionFactorToSI { 6894.757  }  Description { 'Pounds per Square Inch' }

" ======================================================================================================================================================
" Area units
" ======================================================================================================================================================

Define AreaUnit { in2 }

in2    ConversionFactorToSI { 6.4516e-4 }  Description { 'Square Inches' }
